// Author : Pierre Vuillemin (2016)
// License : CECILL

function problem = sopi_addObjective(problem, fun)
   problem.objective = fun
   if fun.isLinear then
      problem.objType   = 0
      q = sopi_extractConstantPart(fun)
      c = sopi_extractCFromObj(problem, fun)
      problem.fun = struct('c',c,'q',q)
   else
      error("Only linear objective functions are handled in this version")
   end
endfunction


function c = sopi_extractCFromObj(problem, fun)
   out   = sopi_extractLinearPart(fun)
   nvar  = problem.nvar
   c     = zeros(nvar,1)
   for o = out
      idx      = sopi_getVarIdxInProblem(problem, o(3)) 
      ci       = o(2) .*. o(1)
      c(idx)   = ci
   end
endfunction
